<?php

//Script Name: Parts Functions
//Revision No.: 1.01
//Revision Date: 09/10/2010
	
	
 	function querymakes()
	{	

		
		//query the database
		$sqlquery = 'SELECT [Make] FROM [dbo].[LiveStock]';
		
		//if the site code is enabled for this site, then query by client id
		if(sitecodeenabled()){$sqlquery .= " WHERE [ClientID] = '1060'";}

		$sqlquery .= 'GROUP BY [Make] ORDER BY [Make] ASC';
		
		$query = mssql_query_upgrade($sqlquery, dblink());
		
		// Did the query fail?
		if (!$query) {
			die('MSSQL error: ' . mssql_get_last_message_upgrade());
		}
		
		//pull in the values to an array
		$arr_make = array();
		$arr_make["all"] = "All Makes";
		for ($i = 0; $i < mssql_num_rows_upgrade($query); ++$i) {
        	$arr_make[$i] = mssql_result_upgrade($query, $i, 'Make');

    	}
		
		//add array for all makes
		
		
		//find all the unique values in this array
		$arr_make = array_values(array_unique($arr_make));
		
		//return the array
		return $arr_make;
	}
	
	function querymodels()
	{
		//query the database
		
		$sqlquery = 'SELECT [Model] FROM [dbo].[LiveStock]';
		//if the site code is enabled for this site, then query by client id
		if(sitecodeenabled()){$sqlquery .= " WHERE [ClientID] = '".sitecode()."'";}
		$sqlquery .= ' GROUP BY [Model] ORDER BY [Model] ASC';
		
		$query = mssql_query_upgrade($sqlquery, dblink());
		
		// Did the query fail?
		if (!$query) {
			die('MSSQL error: ' . mssql_get_last_message_upgrade());
		}
		
		//pull in the values to an array
		$arr_model = array();
		$arr_model["all"] = "All Models";
		for ($i = 0; $i < mssql_num_rows_upgrade($query); ++$i) {
        	$arr_model[$i] = mssql_result_upgrade($query, $i, 'Model');
    	}
		
		//find all the unique values in this array
		$arr_model = array_values(array_unique($arr_model));
		
		//return the array
		return $arr_model;
	}
	
	
	function queryparttypes()
	{
		
		//query the database
		$sqlquery = 'SELECT [PartType] FROM [dbo].[LiveStock]';
		
		//if the site code is enabled for this site, then query by client id
		if(sitecodeenabled()){$sqlquery .= " WHERE [ClientID] = '".sitecode()."'";}

		$sqlquery .= ' GROUP BY [PartType] ORDER BY [PartType] ASC';
		
		$query = mssql_query_upgrade($sqlquery, dblink());
		
		// Did the query fail?
		if (!$query) {
			die('MSSQL error: ' . mssql_get_last_message_upgrade());
		}
		
		//pull in the values to an array
		$arr_parttype = array();
		$arr_parttype["all"] = "All Part Types";
		for ($i = 0; $i < mssql_num_rows_upgrade($query); ++$i) {
        	$arr_parttype[$i] = mssql_result_upgrade($query, $i, 'PartType');
    	}
		
		//find all the unique values in this array
		$arr_parttype = array_values(array_unique($arr_parttype));
		
		//return the array
		return $arr_parttype;
	}
	
	
	function makemodels()
	{
 		//generate an array with each key as the available makes and each value as an array of all possible models in that make
		$arr_makemodel = array();
		
		//foreach key and value in make array
		foreach(querymakes() as $k=> $v){
	  		//if make is all makes then query all models
			if($v=="All Makes"){
			//get all models
			//query the database
			$sqlquery = 'SELECT [Model] FROM [dbo].[LiveStock]';
			
			//if the site code is enabled for this site, then query by client id
			if(sitecodeenabled()){$sqlquery .= " WHERE [ClientID] = '".sitecode()."'";}
	
			$sqlquery .= ' GROUP BY [Model] ORDER BY [Model] ASC';
			
			$query = mssql_query_upgrade($sqlquery, dblink());
		
			}else{		
			//get the corresponding models
			//query the database
			$sqlquery = 'SELECT [Model] FROM [dbo].[LiveStock]';
			
			//if the site code is enabled for this site, then query by client id
			if(sitecodeenabled()){$sqlquery .= " WHERE [ClientID] = '".sitecode()."' AND ";}
			else{$sqlquery .= " WHERE";}
	
			$sqlquery .= ' [Make] = \''. $v .'\' GROUP BY [Model] ORDER BY [Model] ASC';
			
			$query = mssql_query_upgrade($sqlquery, dblink());
		
			}
			//pull in the values to an array
			$arr_models = array();
			$arr_models["aa"] = "Please choose a model";
			$arr_models["all"] = "All Models";
			for ($i = 0; $i < mssql_num_rows_upgrade($query); ++$i) {
				$arr_models[$i] = mssql_result_upgrade($query, $i, 'Model');
			}
			
			//add the current model array to the key make in the makemodel arrray
			$arr_makemodel[$v] = array_values(array_unique($arr_models));
		
	  	}
		
		return $arr_makemodel;
	}
	
	function modelparttypes($make, $model)
	{
 		//generate an array with each key as the available models and each value as an array of all possible parttypes in that model
		$arr_modelparttypes = array();
		
		//start the sql string
		$sqlquery = "SELECT [PartType] FROM [dbo].[LiveStock] ";
			 
		//start the sql where str
		$sqlwhere = "";
		
		//if make has been set to all makes
		if($make=="All Makes"){}else{
			//put a where in
			$sqlwhere .= "[Make] = '". $make ."' AND ";
		}
		
		//if model has been set to all models
		if($model=="All Models"){}else{
			//put a where in
			$sqlwhere .= "[Model] = '". $model ."' AND ";
		}
		
		//if sqlwhere has more than three characters, chop the last AND off and add it to the query string
		if(strlen($sqlwhere)>4){
			$sqlwhere = substr($sqlwhere,0,-4);
		$sqlquery .= " WHERE ".$sqlwhere;
		}
		
		
		//finish the query
		$sqlquery .= "GROUP BY [PartType] ORDER BY [PartType] ASC";
		
		
		//perform query
		$query = mssql_query_upgrade($sqlquery, dblink());
			
		
		//pull in the values to an array
		$arr_modelparttypes = array();
		$arr_modelparttypes["all"] = "All Part Types";
		for ($i = 0; $i < mssql_num_rows_upgrade($query); ++$i) {
			$arr_modelparttypes[$i] = mssql_result_upgrade($query, $i, 'PartType');
		}
		
		//make the values unique
		$arr_modelparttypes = array_unique($arr_modelparttypes);
	
		return $arr_modelparttypes;
	}



function parttypesnames($make, $model, $parttype)
	{
 		//generate an array with each value the partname from the query
		$arr_parttypesnames = array();
		
		//start the sql string
		$sqlquery = "SELECT [PartName] FROM [dbo].[LiveStock] ";
			 
		//start the sql where str
		$sqlwhere = "";
		
		//if part type is all part types then query all part names
		if($parttype=="All Part Types"){}else{
			//put a where in
			$sqlwhere .= "[PartType] = '". $parttype ."' AND ";
		}
		
		//if make has been set to all makes
		if($make=="All Makes"){}else{
			//put a where in
			$sqlwhere .= "[Make] = '". $make ."' AND ";
		}
		
		//if model has been set to all models
		if($model=="All Models"){}else{
			//put a where in
			$sqlwhere .= "[Model] = '". $model ."' AND ";
		}
		
		//if sqlwhere has more than three characters, chop the last AND off and add it to the query string
		if(strlen($sqlwhere)>4){
			$sqlwhere = substr($sqlwhere,0,-4);
		$sqlquery .= " WHERE ".$sqlwhere;
		}
		
		//finish the query
		$sqlquery .= "GROUP BY [PartName] ORDER BY [PartName] ASC";
		
		
		//perform query
		$query = mssql_query_upgrade($sqlquery, dblink());
			
		//pull in the values to an array
		$arr_partnames = array();
		$arr_partnames["all"] = "All Parts";
		for ($i = 0; $i < mssql_num_rows_upgrade($query); ++$i) {
			$arr_partnames[$i] = mssql_result_upgrade($query, $i, 'PartName');
		}
		
		//make the values unique
		$arr_partnames = array_unique($arr_partnames);

		return $arr_partnames;
	}
	
	
	function querypartslist($querymake, $querymodel, $queryptype, $querypname, $queryyear, $page)
	
		{
	
		//check that a query was pushed
		  if($querymake=="0" || $querymodel=="0" || $queryptype=="0" || $querypname=="0"){
			  //query not sent
			  echo "No data in form";
			  $page="1";
			  $totalpages="1";
		  }else{
			  //was sent
			  
			  //setup a filter array
			  $filter = array();
			  //filter counter
			  $filteri = 0;
			  
			  //find all the filters which are applicable
			  if($querymake=="All Makes"){}else{$filter[$filteri]="[Make] = '".$querymake."'";++$filteri;}
			  if($querymodel=="All Models"){}else{$filter[$filteri]="[Model] = '".$querymodel."'";++$filteri;}
			  if($queryptype=="All Part Types"){}else{$filter[$filteri]="[PartType] = '".$queryptype."'";++$filteri;}
			  if($querypname=="All Parts"){}else{$filter[$filteri]="[PartName] = '".$querypname."'";++$filteri;}
			if($queryyear=="All Years"){}else{$filter[$filteri]="[Year] Like '%".$queryyear."%'";++$filteri;}	
				
				
				//calc the top requirement for the page
				$toppage = intval($page)*12;
				
			  $querycode = "SELECT * FROM (SELECT TOP 12 * FROM (SELECT TOP ".$toppage." [ID], [Details], [Price], [PartName], [StockID] FROM  [dbo].[LiveStock] WHERE ";
				//used if the clientid isnt being used
			 // if($filteri > 0){$querycode.=' WHERE ';-}
			 
			 //find all the set filters 
			  $filtercode = "";
			  for ($i = 0; $i < $filteri; ++$i) {
			  $filtercode.= $filter[$i];
			  $filtercode.= ' AND ';
			  }	  
			  
			  //if the site code is enabled for this site, then query by client id or trim the last and
			if(sitecodeenabled()){$filtercode .= "[ClientID] = '".sitecode();}
			else{$filtercode = substr($filtercode,0,-4);}
			  
			  //trim the where off if there are no filters
			  if(!$filtercode){
			  	$querycode=substr($querycode,0,-7);
			  }

			  
			  //and add them to the querycode
			  $querycode.= $filtercode;
				
				//finish the top part of the query
				$querycode.= " ORDER BY [ID] ASC) AS tbl1 ORDER BY [ID] DESC) AS tbl2 ORDER BY [ID] ASC";
				
				//countquery code start
				$countquerycode = "SELECT Count([ID]) FROM [dbo].[LiveStock] WHERE ";
				
				//trim the where off if there are no filters
				if(!$filtercode){
			  		$countquerycode=substr($countquerycode,0,-7);
			  	}
			  
			  //count for the total rows
			  $countquery = mssql_query_upgrade($countquerycode.$filtercode, dblink());
							
				$row = mssql_fetch_array_upgrade($countquery);
				
				if(round(intval($row[0]) / 12) < (intval($row[0]) / 12)){$totalpages = round((intval($row[0])) / 12) + 1;}else{$totalpages = round(intval($row[0]) / 12);}
				
			  //query the database
			  $query = mssql_query_upgrade($querycode, dblink());
	
			
				
				// Did the query fail?
				if (!$query) {
					die('MSSQL error: ' . mssql_get_last_message_upgrade());
				}
				
				//pull in the values to an array
				$arr_details = array();
				$arr_price = array();
				$arr_id = array();
				$arr_PartName = array();
				$arr_stockid = array();
				
				//find the total number of rows in this query
				$trows = mssql_num_rows_upgrade($query);
				
				//for each row, assign the arrays values
				for ($i = 0; $i < $trows; ++$i) {
					$arr_details[$i] = mssql_result_upgrade($query, $i, 'Details');
					$arr_PartName[$i] = mssql_result_upgrade($query, $i, 'PartName');
					$arr_price[$i] = mssql_result_upgrade($query, $i, 'Price');
					$arr_id[$i] = mssql_result_upgrade($query, $i, 'ID');
					$arr_stockid[$i] = mssql_result_upgrade($query, $i, 'StockID');
				}
			
		
			$arr_return = array();
			
			$arr_return["details"] = $arr_details;
			$arr_return["partname"] = $arr_PartName;
			$arr_return["price"] = $arr_price;
			$arr_return["id"] = $arr_id;
			$arr_return["stockid"] = $arr_stockid;
			$arr_return["page"] = $page;
			$arr_return["totalpages"] = $totalpages;
			$arr_return["trows"] = $trows;
			$arr_return["i"] = $i;
			
			return $arr_return;
			
		}
		
	}
	
	
	function getpartdetails($partid)
	{
		
$query = mssql_query_upgrade('SELECT [ID], [StockID], [Details], [Price] as Price, [PartName], [Make], [Model], [PartType], [manufact_year], [Engine], [Condition], [ClientID], [Year] FROM [dbo].[LiveStock] WHERE [ID] = \''.$partid.'\'', dblink());
				
		if (!$query) {
			die('MSSQL error: ' . mssql_get_last_message_upgrade());
		}
		
		//create an arry to return the details
		$arr_return = array();
		
		if(mssql_num_rows_upgrade($query)<1){
		
		}else{
			
			for ($i = 0; $i < 1; ++$i) {
				$arr_return["details"] = mssql_result_upgrade($query, $i, 'Details'); 
				$arr_return["PartName"] = mssql_result_upgrade($query, $i, 'PartName');
				$arr_return["price"] = mssql_result_upgrade($query, $i, 'Price');
				$arr_return["make"] = mssql_result_upgrade($query, $i, 'Make');
				$arr_return["model"] = mssql_result_upgrade($query, $i, 'Model');
				$arr_return["ptype"] = mssql_result_upgrade($query, $i, 'PartType');
				$arr_return["manuyear"] = mssql_result_upgrade($query, $i, 'manufact_year');
				$arr_return["engine"] = mssql_result_upgrade($query, $i, 'Engine');
				$arr_return["condition"] = mssql_result_upgrade($query, $i, 'Condition');
				$arr_return["stockid"] = mssql_result_upgrade($query, $i, 'StockID');
				$arr_return["clientid"] = mssql_result_upgrade($query, $i, 'ClientID');
				$arr_return["year"] = mssql_result_upgrade($query, $i, 'Year');
			}
		}
			  
		return $arr_return;
	
	
	}
	
	function stockidtopartid($stockid)
	
	{	
		$query = mssql_query_upgrade('SELECT [ID] FROM [dbo].[LiveStock] WHERE [StockID] = \''.$stockid.'\'', dblink());
		$return = mssql_result_upgrade($query, 0, 'ID');
		
		return $return;
	
	}
	
	
	function supplierdetails($clientid)
	{
		
		$query = mssql_query_upgrade('SELECT [Company], [City], [Town], [Postcode], [Country], [Tel], [NochexEmailAccount], [Email], [ContactName], [ContactNumber], [ClientGroup], [Paypal_email], [CurrencyCode], [CurrencyPrefix], [MapPosition] FROM [dbo].[Clients] WHERE [ClientID] = \''.$clientid.'\'', dblink());
				
		if (!$query) {
			die('MSSQL error: ' . mssql_get_last_message_upgrade());
		}
		
		//create an arry to return the details
		$arr_return = array();
		
		if(mssql_num_rows_upgrade($query)<1){
		
		}else{
			
			for ($i = 0; $i < 1; ++$i) {
				$arr_return["Company"] = mssql_result_upgrade($query, $i, 'Company');
				$arr_return["City"] = mssql_result_upgrade($query, $i, 'City');
				$arr_return["Town"] = mssql_result_upgrade($query, $i, 'Town');
				$arr_return["Postcode"] = mssql_result_upgrade($query, $i, 'Postcode');
				$arr_return["Country"] = mssql_result_upgrade($query, $i, 'Country');
				$arr_return["Tel"] = mssql_result_upgrade($query, $i, 'Tel');
				$arr_return["NochexEmailAccount"] = mssql_result_upgrade($query, $i, 'NochexEmailAccount');
				$arr_return["Email"] = mssql_result_upgrade($query, $i, 'Email');
				$arr_return["ContactName"] = mssql_result_upgrade($query, $i, 'ContactName');
				$arr_return["ContactNumber"] = mssql_result_upgrade($query, $i, 'ContactNumber');
				$arr_return["ClientGroup"] = mssql_result_upgrade($query, $i, 'ClientGroup');
				$arr_return["Paypal_email"] = mssql_result_upgrade($query, $i, 'Paypal_email');
				$arr_return["CurrencyCode"] = mssql_result_upgrade($query, $i, 'CurrencyCode');
				$arr_return["CurrencyPrefix"] = iconv("ISO-8859-15","UTF-8",mssql_result_upgrade($query, $i, 'CurrencyPrefix'));
				$arr_return["MapPosition"] = mssql_result_upgrade($query, $i, 'MapPosition');
			}
		}
			  
		return $arr_return;
	
	
	}
	
	
    ?>