<?php
header('Content-Type: application/json');
require 'mageconfig.php';

function remoteFileExists($url) {
    $curl = curl_init($url);
    //don't fetch the actual page, you only want to check the connection is ok
    curl_setopt($curl, CURLOPT_NOBODY, true);
    curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
    //do request
    $result = curl_exec($curl);
    $ret = false;
    //if request did not fail
    if ($result !== false) {
        //if request was ok, check response code
        $statusCode = curl_getinfo($curl, CURLINFO_HTTP_CODE);  
        if ($statusCode == 200) {
            $ret = true;   
        }
    }
    curl_close($curl);
    return $ret;
}

if(isset($_REQUEST['client_id']) && $_REQUEST['client_id']!='' && isset($_REQUEST['action']) && $_REQUEST['action']!=''){ 
//if(isset($_REQUEST['client_id']) && $_REQUEST['client_id']!='' && isset($_REQUEST['stock_id']) && $_REQUEST['stock_id']!='' && isset($_REQUEST['action']) && $_REQUEST['action']!=''){	
$client_id = $_REQUEST['client_id'];
$stock_id  = $_REQUEST['stock_id'];
$action   = $_REQUEST['action'];

$conn_var = dblink();
$query_array=array();
$static_array=array();

/*Api Request Generate */
$sqlquery = 'Select [MagentoAPI_Username],[MagentoAPI_Token], [MagentoAPI_URL]  from [Clients] where [ClientID]='.$client_id;
$query = mssql_query_upgrade($sqlquery, dblink());
$clientdata= mssql_fetch_array_upgrade($query);

$magento_username =  $clientdata['MagentoAPI_Username'];
$magento_token    =  $clientdata['MagentoAPI_Token'];
$magento_url      =  $clientdata['MagentoAPI_URL'];
//var_dump($clientdata);

if(empty($magento_username) || empty($magento_token) || empty($magento_url))
{
	echo 'There was some error in connection.';
	exit;
}	

$client = new SoapClient($magento_url);
$session = $client->login($magento_username, $magento_token);

//$client = new SoapClient('http://vaux-spares.co.uk/api/soap/?wsdl');
//$session = $client->login('vauxspares', '@dmin!23#');

         try{
          $product_exist=$client->call($session, 'product.info',array($stock_id));
          }
          catch(exception $e){}

/* Start of Product Insert Code */
if($action=='insert'){	

    if($product_exist!=null or  $product_exist!=""){
	  echo 'Product having Stock_ID :'.$stock_id.' already exists.';
	  exit;
	}

$querynew = "SELECT Top 1 [ID]  ,[StockID],[VehicleID]  ,[ClientID]  ,[AccountID]  ,[Make]  ,[Model]  ,[PartType], [PartName]  ,[nDetails]  ,[Price]  ,[Year]  ,[manufact_year]  ,[Engine]  ,[Condition], [fuel]  , [colour]  ,[mileage]  ,CAST([ImageThumbnailURLList] as [text]) ImageThumbnailURLList, CAST([ImageURLList] as [text]) ImageURLList, CAST([ImageStandardURLList] as [text]) ImageStandardURLList,CAST([Ebay_PicURL] as [text]) Ebay_PicURL, CAST([Keywords] as [text]) Keywords, [WEB_Price] ,[Magento_CATID], CAST([Details] as [TEXT]) Details, CAST([ebay_title] as [text]) ebay_title FROM [automatch].[dbo].[LiveStock] where [StockID]='".$stock_id."' AND [ClientID]='".$client_id."'";


$dataquery    = mssql_query_upgrade($querynew, dblink());
$countrowdata = mssql_num_rows_upgrade($dataquery);
$rowdata   = mssql_fetch_array_upgrade($dataquery);
//print_r($rowdata);	

if($countrowdata < 1){
	echo 'No data exists for stock_id : '.$stock_id;
	exit;
}

// get attribute set
$attributeSets = $client->call($session, 'product_attribute_set.list');
$attributeSet = current($attributeSets);

/*Some*/
if($rowdata['ebay_title']!=''){
	$partname = $rowdata['ebay_title'];
	$partname_url = url_slug($rowdata['ebay_title']);
}  

//$images = $rowdata['ImageURLList'];
//$images = $rowdata['ImageStandardURLList'];

//$thumbimages = $rowdata['ImageThumbnailURLList'];
//$image_arr=$images.','.$thumbimages;
$images = $rowdata['ImageURLList'];

if($rowdata['ImageURLList']!=''){
	$images = $rowdata['ImageURLList'];	 
} else {
	$images = $rowdata['ImageStandardURLList']; 
}
$image_arr=$images;

$category_ids =array();
if(!is_null($rowdata['Magento_CATID'])){
$category_ids = explode(',', $rowdata['Magento_CATID']);
}else{
$category_ids[] = 2;	
}
 
if($rowdata['WEB_Price']==0.00 || $rowdata['WEB_Price']=='0.00'){
	echo 'Api Called Successfully : Adding Stock Ignored as No Price set';
	exit;
}

$description = htmlentities($rowdata['Details']);
$description .=  $description. '<li> Our Ref: '.$rowdata['StockID'].'</li>';

$result = $client->call($session, 'catalog_product.create', array('simple', $attributeSet['set_id'], $rowdata['StockID'], array(
    'categories' => $category_ids,
    'name' => htmlentities($partname),
    'description' => $description,
    'short_description' => htmlentities($rowdata['Details']),
    'weight' => '10',
    'status' => '1',
    'url_key' => htmlentities($partname),
    'visibility' => '4',
    'price' => $rowdata['WEB_Price'],
    'tax_class_id' => 0,
    'meta_title' => htmlentities($rowdata['Keywords']),
    'meta_keyword' => htmlentities($rowdata['Keywords']),
    'meta_description' => htmlentities($rowdata['Details'])
)));

if($image_arr!='' && $result==true){
$thumbimages = explode(',', $image_arr);
$sortorder=2;


foreach($thumbimages as $thumbimage){
	
$filenameval = explode('/', $thumbimage);
$filename = $filenameval[count($filenameval)-1];


	if(remoteFileExists($thumbimage))
	{ 
		if($sortorder==2){
		$image_display_types=array('image','small_image');
		}else{
		$image_display_types=array('thumbnail');	
		}
	
//echo 'mime:'.$mimetype = mime_content_type($filename);
$image_ext  = explode('.',$filename); 

if($image_ext[1]=='png'){
$mimetype = "image/png";
}else if($image_ext[1]=='jpeg' || $image_ext[1]=='jpg'){
$mimetype = "image/jpeg";
} else if ($image_ext[1]=='gif'){
$mimetype = "image/gif";	
}	

$insertImage = array(
    'file' => array(
        'name' => $filename,
        'content' => base64_encode(file_get_contents($thumbimage)),
        'mime'    => $mimetype
    ),
    'label'    => htmlentities($filename),
    'position' => $sortorder,
    'types'    => $image_display_types,
    'exclude'  => 0
);
$imageFilename = $client->call($session, 'product_media.create', array($stock_id, $insertImage));
$sortorder++;

var_dump($imageFilename);

    }
	
	$i++;
}
		if($result){
			echo 'Product Saved Successfully.';
		} else{
			echo 'Product could not be Saved.';
		}

	}
  }
/* End of Product Insert*/

/* For Product delete*/
if($action=='delete'){
	
    if($product_exist==null or  $product_exist==""){
	  echo 'No such Product having Stock_ID :'.$stock_id.' exists';
	  exit;
	}
$result = $client->call($session, 'catalog_product.delete', $stock_id);

if($result){
	echo 'Product Deleted Successfully.';
} else{
	echo 'Product could not be deleted.';
}
// If you don't need the session anymore
$client->endSession($session);
}

/* for categories*/
if($action=='getcategories'){  

function array_to_xml($array, &$xml_user_info) { 
    foreach($array as $key => $value) {
        if(is_array($value)) { 
            if(!is_numeric($key)){
                $subnode = $xml_user_info->addChild("$key");
                array_to_xml($value, $subnode);
            }else{
                $subnode = $xml_user_info->addChild("category$key");
                array_to_xml($value, $subnode);
            }
        }else {
			 if($key=='category_id' || $key=='name'){
            $xml_user_info->addChild("$key",htmlspecialchars("$value"));
             }
		}
    }
}

$allCategories = $client->call($session, 'category.tree');
//var_dump($allCategories);
$xml_category_info = new SimpleXMLElement("<?xml version=\"1.0\"?><category></category>");
array_to_xml($allCategories, $xml_category_info);
$xml_file = $xml_category_info->asXML('categories.xml');
print $xml_category_info->asXML();

// If you don't need the session anymore
$client->endSession($session);
}
/* End of Categories */

} else {
	echo 'Invalid Inputs';
}
?>