<?php
class SimpleImage {
	var $image;
	var $image_type;
	var $filename	= array();
	function load($filename) {
		ini_set ('gd.jpeg_ignore_warning', 1);
		$image_info = getimagesize($filename);
		$this -> image_type = $image_info[2];
		$this -> image_mime = $image_info['mime'];
		echo "<pre>";
		echo "Image Type : ".$image_info['mime'];
		//exit;
		if($this -> image_type == IMAGETYPE_JPEG) {
			$this -> image = @imagecreatefromjpeg($filename);
		} elseif($this -> image_mime == 'image/x-ms-bmp') {
			$this -> image = ImageCreateFromBMP($filename);
		} elseif($this -> image_type == IMAGETYPE_PNG) {
			$this -> image = imagecreatefrompng($filename);
		}elseif($this -> image_mime == 'image/bmp') {
			$this -> image = ImageCreateFromBMP($filename);
		} 
	}

	function save($filename, $image_type=IMAGETYPE_JPEG, $compression=95, $permissions=null) {
		if($image_type == IMAGETYPE_JPEG) {
			imagejpeg($this -> image, $filename, $compression);
		} elseif($image_type == IMAGETYPE_GIF) {
			imagegif($this -> image, $filename);
		} elseif($image_type == IMAGETYPE_PNG) {
			imagepng($this -> image, $filename);
		}
		if($permissions != null) {
			chmod($filename, $permissions);
		}
	}

	function output($image_type=IMAGETYPE_JPEG) {
		if($image_type == IMAGETYPE_JPEG) {
			imagejpeg($this -> image);
		} elseif($image_type == IMAGETYPE_GIF) {
			imagegif($this -> image);
		} elseif($image_type == IMAGETYPE_PNG) {
			imagepng($this -> image);
		}
	}

	function getWidth() {
		return   imagesx($this -> image);
	}

	function getHeight() {
		return   imagesy($this -> image);
	}
	function resizeToHeight($height) {
		$ratio = $height / $this -> getHeight();
		$width = $this -> getWidth() * $ratio;
		$this -> resize($width, $height);
	}

	function resizeToWidth($width) {
		$ratio = $width / $this -> getWidth();
		$height = $this -> getheight() * $ratio;
		$this -> resize($width, $height);
	}

	function scale($scale) {
		$width = $this -> getWidth() * $scale / 100;
		$height = $this -> getheight() * $scale / 100;
		$this -> resize($width, $height);
	}

	function resize($width, $height) {
		$new_image = imagecreatetruecolor($width, $height);
		imagecopyresampled($new_image, $this -> image, 0, 0, 0, 0, $width, $height, $this -> getWidth(), $this -> getHeight());
		$this -> image = $new_image;
	}
}

function ImageCreateFromBMP($filename)
{
 //Ouverture du fichier en mode binaire
   if (! $f1 = fopen($filename,"rb")) return FALSE;

 //1 : Chargement des ent�tes FICHIER
   $FILE = unpack("vfile_type/Vfile_size/Vreserved/Vbitmap_offset", fread($f1,14));
   if ($FILE['file_type'] != 19778) return FALSE;

 //2 : Chargement des ent�tes BMP
   $BMP = unpack('Vheader_size/Vwidth/Vheight/vplanes/vbits_per_pixel'.
                 '/Vcompression/Vsize_bitmap/Vhoriz_resolution'.
                 '/Vvert_resolution/Vcolors_used/Vcolors_important', fread($f1,40));
   $BMP['colors'] = pow(2,$BMP['bits_per_pixel']);
   if ($BMP['size_bitmap'] == 0) $BMP['size_bitmap'] = $FILE['file_size'] - $FILE['bitmap_offset'];
   $BMP['bytes_per_pixel'] = $BMP['bits_per_pixel']/8;
   $BMP['bytes_per_pixel2'] = ceil($BMP['bytes_per_pixel']);
   $BMP['decal'] = ($BMP['width']*$BMP['bytes_per_pixel']/4);
   $BMP['decal'] -= floor($BMP['width']*$BMP['bytes_per_pixel']/4);
   $BMP['decal'] = 4-(4*$BMP['decal']);
   if ($BMP['decal'] == 4) $BMP['decal'] = 0;

 //3 : Chargement des couleurs de la palette
   $PALETTE = array();
   if ($BMP['colors'] < 16777216)
   {
    $PALETTE = unpack('V'.$BMP['colors'], fread($f1,$BMP['colors']*4));
   }

 //4 : Cr�ation de l'image
   $IMG = fread($f1,$BMP['size_bitmap']);
   $VIDE = chr(0);

   $res = imagecreatetruecolor($BMP['width'],$BMP['height']);
   $P = 0;
   $Y = $BMP['height']-1;
   while ($Y >= 0)
   {
    $X=0;
    while ($X < $BMP['width'])
    {
     if ($BMP['bits_per_pixel'] == 24)
        $COLOR = unpack("V",substr($IMG,$P,3).$VIDE);
     elseif ($BMP['bits_per_pixel'] == 16)
     { 
        $COLOR = unpack("n",substr($IMG,$P,2));
        $COLOR[1] = $PALETTE[$COLOR[1]+1];
     }
     elseif ($BMP['bits_per_pixel'] == 8)
     { 
        $COLOR = unpack("n",$VIDE.substr($IMG,$P,1));
        $COLOR[1] = $PALETTE[$COLOR[1]+1];
     }
     elseif ($BMP['bits_per_pixel'] == 4)
     {
        $COLOR = unpack("n",$VIDE.substr($IMG,floor($P),1));
        if (($P*2)%2 == 0) $COLOR[1] = ($COLOR[1] >> 4) ; else $COLOR[1] = ($COLOR[1] & 0x0F);
        $COLOR[1] = $PALETTE[$COLOR[1]+1];
     }
     elseif ($BMP['bits_per_pixel'] == 1)
     {
        $COLOR = unpack("n",$VIDE.substr($IMG,floor($P),1));
        if     (($P*8)%8 == 0) $COLOR[1] =  $COLOR[1]        >>7;
        elseif (($P*8)%8 == 1) $COLOR[1] = ($COLOR[1] & 0x40)>>6;
        elseif (($P*8)%8 == 2) $COLOR[1] = ($COLOR[1] & 0x20)>>5;
        elseif (($P*8)%8 == 3) $COLOR[1] = ($COLOR[1] & 0x10)>>4;
        elseif (($P*8)%8 == 4) $COLOR[1] = ($COLOR[1] & 0x8)>>3;
        elseif (($P*8)%8 == 5) $COLOR[1] = ($COLOR[1] & 0x4)>>2;
        elseif (($P*8)%8 == 6) $COLOR[1] = ($COLOR[1] & 0x2)>>1;
        elseif (($P*8)%8 == 7) $COLOR[1] = ($COLOR[1] & 0x1);
        $COLOR[1] = $PALETTE[$COLOR[1]+1];
     }
     else
        return FALSE;
     imagesetpixel($res,$X,$Y,$COLOR[1]);
     $X++;
     $P += $BMP['bytes_per_pixel'];
    }
    $Y--;
    $P+=$BMP['decal'];
   }

 //Fermeture du fichier
   fclose($f1);

 return $res;
}
?>